package binarization;

import binarization.data.IBinaryImage;
import binarization.data.IGrayLevelImage;

/**
 * Metodo de binarizaca de imagens em niveis de cinza.
 *
 * @author denis
 * @see IBinaryImage
 * @see IGrayLevelImage
 * @see IBinaryImageMetric
 */
public interface IBinarizationMethod {

	/**
	 * Devolve a imagem binaria resultante da aplicacao deste metodo.
	 * 
	 * @param input a imagem em niveis de cinza da entrada
	 * @return a imagem binaria resultante
	 */
	IBinaryImage binarize(IGrayLevelImage input);

	/**
	 * Devolve o rotulo do metodo. Este rotulo devera ser usado para nomes de arquivos.
	 * Para string mais verbosas, usar o {@link #toString() }.
	 * 
	 * @return o rotulo do metodo
	 */
	String getLabel();
}
