package binarization.data;

/**
 * Imagem binaria vazia. Implementa o padrao Singleton.
 *
 * @author denis
 */
enum EmptyBinaryImage implements IBinaryImage {

	INSTANCE;

	@Override
	public boolean isEmpty() {
		return true;
	}

	@Override
	public ImageSize size() {
		return ImageSize.ofEmpty();
	}

	@Override
	public Pixel pixelAt(ImagePoint p) {
		throw new UnsupportedOperationException("Empty image contains no pixels.");
	}

	@Override
	public Pixel pixelAtUnchecked(int x, int y) {
		throw new UnsupportedOperationException("Empty image contains no pixels.");
	}

	@Override
	public IBinaryImage windowOf(ImagePoint center, ImageSize size) {
		throw new UnsupportedOperationException("Empty image has no valid window.");
	}

	@Override
	public IBinaryImage complement() {
		return this;
	}
}
