package binarization.data;

/**
 * Imagem em niveis de cinza vazia. Implementa o padrao Singleton.
 *
 * @author denis
 */
enum EmptyGrayLevelImage implements IGrayLevelImage {

	INSTANCE;

	@Override
	public boolean isEmpty() {
		return true;
	}

	@Override
	public ImageSize size() {
		return ImageSize.ofEmpty();
	}

	@Override
	public Pixel pixelAt(ImagePoint p) {
		throw new UnsupportedOperationException("Empty image contains no pixels.");
	}

	@Override
	public Pixel pixelAtUnchecked(int x, int y) {
		throw new UnsupportedOperationException("Empty image contains no pixels.");
	}

	@Override
	public IGrayLevelImage windowOf(ImagePoint center, ImageSize size) {
		throw new UnsupportedOperationException("Empty image has no valid window.");
	}

	@Override
	public IGrayLevelImage inverse() {
		return this;
	}

	@Override
	public IHistogram getHistogram() {
		throw new UnsupportedOperationException("Empty image has no valid histogram.");
	}

	@Override
	public int getMinimum() {
		throw new UnsupportedOperationException("Empty image contains no pixels.");
	}

	@Override
	public int getMaximum() {
		throw new UnsupportedOperationException("Empty image contains no pixels.");
	}

	@Override
	public double getMean() {
		throw new UnsupportedOperationException("Empty image has no valid mean.");
	}

	@Override
	public double getStandardDeviation() {
		throw new UnsupportedOperationException("Empty image has no valid standard deviation.");
	}
}