package binarization.data.util;

import binarization.data.IBinaryImage;
import ij.process.BinaryProcessor;

/**
 *
 * @author
 */
public class BinaryImageOperator {

	private BinaryProcessor processor;

	private BinaryImageOperator(IBinaryImage initial) {
		this.processor = ImageOperations.convertToBinaryProcessor(initial);
	}

	public static BinaryImageOperator of(IBinaryImage initial) {
		return new BinaryImageOperator(initial);
	}

	public BinaryImageOperator outline() {
		processor.outline();
		return this;
	}

	public IBinaryImage getResult() {
		return ImageOperations.convertToBinary(processor);
	}

	public GridMarker getEuclidianDistanceTransform() {
		return ImageOperations.doEdm(processor);
	}
}
