package binarization.data.util;

import binarization.data.ImageSize;
import binarization.data.ImagePoint;

/**
 *
 * @author
 */
public class GridMarker {

	private final int[][] values;

	public GridMarker(ImageSize size, int defaultValue) {
		this.values = initializeValues(size, defaultValue);
	}

	private int[][] initializeValues(ImageSize size, int defaultValue) {
		final int[][] initial = new int[size.width()][size.height()];

		for (int x = 0; x < size.width(); x++) {
			for (int y = 0; y < size.height(); y++) {
				initial[x][y] = defaultValue;
			}
		}

		return initial;
	}

	public void set(int x, int y, int value) {
		values[x][y] = value;
	}

	public void set(ImagePoint p, int value) {
		set(p.x(), p.y(), value);
	}

	public int get(int x, int y) {
		return values[x][y];
	}

	public int get(ImagePoint p) {
		return get(p.x(), p.y());
	}
}
