package binarization.methods.loaders;

import binarization.ILoader;
import binarization.IBinarizationMethod;
import binarization.methods.WhiteMethod;
import java.util.Scanner;

/**
 * Classe auxiliar usada para instanciacao por reflexao.
 */
public class WhiteMethodLoader implements ILoader<IBinarizationMethod> {

	/**
	 * Construtor que facilita a instanciacao por reflexao.
	 */
	public WhiteMethodLoader() {
	}

	@Override
	public IBinarizationMethod load(Scanner parameters) {
		if (!parameters.hasNextInt()) {
			throw new IllegalArgumentException("This method needs at least one parameter.");
		}

		final int windowSize = parameters.nextInt();

		if (!parameters.hasNextDouble()) {
			return new WhiteMethod(windowSize);
		}

		final double bias = parameters.nextDouble();

		return new WhiteMethod(windowSize, bias);
	}
}